//
//  CakeXmlParser.swift
//  SwiftCakeSDK
//
//  Created by Brian McCullough on 4/19/16.
//  Copyright © 2016 Accelerize, Inc. All rights reserved.
//

import UIKit

class CakeXmlParser: NSObject, NSXMLParserDelegate {
	
	let deepLinkXmlElement: String = "dlink"
	
	var parser = NSXMLParser()
	var elements = NSMutableDictionary()
	var element = NSString()
	var dlink = NSMutableString()
	
	internal func startParsing(data: NSData) {
		parser = NSXMLParser(data: data)
		parser.delegate = self
		parser.parse()
	}
	
	internal func parser(parser: NSXMLParser, didStartElement elementName: String, namespaceURI: String?, qualifiedName qName: String?, attributes attributeDict: [String : String]) {
		element = elementName
		if (elementName as NSString).isEqualToString(deepLinkXmlElement) {
			elements = NSMutableDictionary()
			elements = [:]
			dlink = NSMutableString()
			dlink = ""
		}
	}
	
	internal func parser(parser: NSXMLParser, didEndElement elementName: String, namespaceURI: String?, qualifiedName qName: String?) {
		if (elementName as NSString).isEqualToString(deepLinkXmlElement) {
			if !dlink.isEqual(nil) {
				elements.setObject(dlink, forKey: "dlink")
			}
		}
	}
	
	internal func parser(parser: NSXMLParser, foundCharacters string: String) {
		if element.isEqualToString(deepLinkXmlElement) {
			dlink.appendString(string)
		}
	}
}